//---------------------------------------------------------------------------
#ifndef GrafoH
#define GrafoH

#include <fstream.h>
#include "Comune.h"

#include "ListaNodi.h"
#include "ListaLegami.h"
#include "Segmento.h"

//---------------------------------------------------------------------------
class grafo {
	ListaNodi 	nodes;         // vettore dinamico di Nodo
    ListaLegami	links;         // vettore dinamico di Legame
    Segmento 	**segmenti;    // vettore dinamico di *Segmento

    int 	statistica;
    int     memIndice,memX,memY;
    int 	lato;
public:
			grafo(ifstream &canale);
            ~grafo();
    void 	leggi_da_file(ifstream &canale);
    void 	scrivi_su_file(ofstream &canale);

    int 	intersezioni();
    int		conflitti();
    int 	intersezioni_legame(int indice);
    int		conflitti_legame(int indice);

    void 	disponi_in_disordine();
    int 	genera_mossa_casuale();
    void 	annulla_mossa();

    void	muovi_nodo(int indice,int pox,int poy);
};



#endif
