//---------------------------------------------------------------------------
#include <vcl\condefs.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

// my inclusion
#include <fstream.h>
#include <stdlib.h>
#include <time.h>
#include <conio.h>
#include <math.h>
#pragma hdrstop

#include "Grafo.h"
//---------------------------------------------------------------------------
USERES("Simulated.res");
USEUNIT("Comune.cpp");
USEUNIT("Object.cpp");
USEUNIT("Grafo.cpp");
USEUNIT("EquazioneRetta.cpp");
USEUNIT("Segmento.cpp");
USEUNIT("ListaNodi.cpp");
USEUNIT("ListaLegami.cpp");
//---------------------------------------------------------------------------
int main(int argc, char **argv) {
    double TEMPERATURA = 1000;
    double cooling_ratio = 0.9;
    double ValorMedio = 5;
    double Boltzman = - ValorMedio / (TEMPERATURA * log(0.5) );
    double T;
    int punteggio;
    double deltaI;
    int probabilita;
    int roll;
    int contatore;
    time_t t;


    //randomize timer;
    srand((unsigned) time(&t));

   	if (argc < 3) {
    	cout << "Uso: simulated <file_origine> <file_dest> [<temperatura>]" << endl;
        exit(0);
  	}

    if (argc == 4) {
    	TEMPERATURA = atof(argv[3]);
     	Boltzman = - ValorMedio / (TEMPERATURA * log(0.5) );
    }

    // open input file
	ifstream file;
    file.open(argv[1]);
	grafo Grafo(file);
    file.close();

    // simulatead annealing
    Grafo.disponi_in_disordine();
    punteggio = Grafo.intersezioni() + Grafo.conflitti();
    T = TEMPERATURA;

    while (T > 1 && punteggio > 0) {
    	contatore = 0;
    	do {
        	deltaI = Grafo.genera_mossa_casuale();
            contatore ++;

            if (deltaI < 0) {	// miglioramento
            	punteggio += (int) deltaI;
            } else {
            	probabilita = (int) floor( exp( - deltaI / (Boltzman * T) ) * 100 + 0.5 );
                roll = casuale (100);

                if (roll < probabilita) {
                	punteggio += (int) deltaI;
                } else {
                	Grafo.annulla_mossa();
                }
            }
        } while (deltaI >= 0 && contatore < 1000);

        T *= cooling_ratio;

        punteggio = Grafo.intersezioni() + Grafo.conflitti();
    }

    // write output file
    ofstream output;
    output.open(argv[2]);
    Grafo.scrivi_su_file(output);

    // personal statistic informations
    output << endl << "intersezioni: " << Grafo.intersezioni() << endl;
    output << endl << "conflitti: " << Grafo.conflitti() << endl;
    output.close();

	return 0;
}
//---------------------------------------------------------------------------
